# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
class for Crazy Eddies GUI
"""


import os

from twisted.internet import reactor
from twisted.internet import defer

from ogre.gui import CEGUI as cegui
from ogre.renderer import OGRE as ogre
from ogre.io import OIS

from mv3d.util.date import Date


def cegui_reldim ( x ) :
    """
    You need to add a docstring here ! 
    """
    return cegui.UDim((x), 0)


class MouseListener(OIS.MouseListener):
    """
    You need to add a docstring here ! 
    """
    def __init__(self, ui):
        OIS.MouseListener.__init__(self)
        self.ui = ui


    def mousePressed(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.mousePressed( * args)


    def mouseMoved(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.mouseMoved( * args)


    def mouseDragged(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.mouseMoved( * args)


    def mouseReleased(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.mouseReleased( * args)



class KeyListener(OIS.KeyListener):
    """
    You need to add a docstring here ! 
    """
    def __init__(self, ui):
        OIS.KeyListener.__init__(self)
        self.ui = ui


    def keyPressed(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.keyPressed( * args)


    def keyReleased(self, *args):
        """
        You need to add a docstring here ! 
        """
        #print args
        return self.ui.keyReleased( * args)



class UICallback:
    """
    You need to add a docstring here ! 
    """
    def __init__(self, cbf, mth=""):
        self.cbf = cbf
        if mth != "":
            self.cbf = getattr(cbf, mth)


    def call(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.cbf(args)
        except:
            import traceback
            traceback.print_exc()


    def subscribe(self, comp, ev):
        """
        You need to add a docstring here ! 
        """
        self.sub = comp.subscribeEvent(ev, self, "call")


    def unsubscribe(self):
        """
        You need to add a docstring here ! 
        """
        self.sub.disconnect()



class CEGUI(ogre.FrameListener, ogre.WindowEventListener):
    """
    This class should be subclassed by other classes
        that provide a specific implimentation of a user interface
    """
    def __init__(self, client):
        #ogre.CombinedListener.__init__(self)
        ogre.FrameListener.__init__(self)
        ogre.WindowEventListener.__init__(self)
        self.client = client
        self.uicallbacks = {}
        self.keycallbacks = {}
        self.mousecallbacks = []
        self.numScreenShots = 1
        # repeat key ---------------------
        self.repeatkeyPressed = False   # repeatKey flag
        self.keyTime = 0.0              # holds time since last key inject
        self.keyDelay = 0.0             # holds current time delay to compare
            # against initialdelay
        self.key = 0                    # holds repeat key
        self.keyChar = ""               # holds repeat char
        self.keydelta = 0.035            # rate repeat key, make larger slow down, if too fast
        self.initialdelay = 0.30        # delay before repeat key kicks in
        self.disabled = 0
        self.mousebuttons = [0, 0, 0]


    def initialize(self, renderer=None, **kw):
        """
        You need to add a docstring here ! 
        """
        self.renderer = renderer
        # if not kw.get("window", True):
            # return
        self.guiRenderer = cegui.OgreCEGUIRenderer(self.renderer.renderWindow, ogre.RENDER_QUEUE_OVERLAY, False, 
            3000, self.renderer.sceneManager)
        self.system = cegui.System(self.guiRenderer)
        cegui.Logger.getSingleton().loggingLevel = cegui.Insane
        cegui.SchemeManager.getSingleton().loadScheme("WindowsLook.scheme")
        cegui.SchemeManager.getSingleton().loadScheme("TaharezLook.scheme")
        self.system.setDefaultMouseCursor("WindowsLook",  "MouseArrow")
        cegui.FontManager.getSingleton().createFont("Commonwealth-10.font")
        cegui.ImagesetManager.getSingleton().createImagesetFromImageFile("BackgroundImage", "Blank.png")
        ## here we will use a StaticImage as the root, then we can use it to place a background image
        background = cegui.WindowManager.getSingleton().createWindow("TaharezLook/StaticImage", "background_wnd")
        ## set position and size
        background.setPosition(cegui.UVector2(cegui_reldim(0), cegui_reldim( 0)))
        background.setSize(cegui.UVector2(cegui_reldim(1), cegui_reldim( 1)))
        ## disable frame and standard background
        background.setProperty("FrameEnabled", "false")
        background.setProperty("BackgroundEnabled", "false")
        ## set the background image
        background.setProperty("Image", "set:BackgroundImage image:full_image")
        background.setAlpha(1.0)
        self.background = background
        ## install this as the root GUI sheet
        cegui.System.getSingleton().setGUISheet(background)
        self.MouseListener = MouseListener(self)
        self.KeyListener = KeyListener(self)
        self.renderer.Mouse.setEventCallback(self.MouseListener)
        self.renderer.Keyboard.setEventCallback(self.KeyListener)


    def finalize(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def iterate(self, time):
        """
        You need to add a docstring here ! 
        """
        pass


    def mouseDragged(self, evt):
        """
        You need to add a docstring here ! 
        """
        self.mouseMoved(evt)


    def mousePressed(self, arg, butt):
        """
        You need to add a docstring here ! 
        """
        try:
            evt = arg.get_state()
            button = self._convertOgreButtonToCegui(butt)
            cegui.System.getSingleton().injectMouseButtonDown(button)
            #print "Mouse button down",butt
            if butt == OIS.MouseButtonID.MB_Left:
                self.mousebuttons[0] = 1
            if butt == OIS.MouseButtonID.MB_Middle:
                self.mousebuttons[1] = 1
            if butt == OIS.MouseButtonID.MB_Right:
                self.mousebuttons[2] = 1
            #print "Down",self.mousebuttons
            if len(self.mousecallbacks):
                pos = (evt.X.abs, evt.Y.abs, evt.Z.abs)
                rel = (evt.X.rel, evt.Y.rel, evt.Z.rel)
                mods = (self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Ctrl), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Alt), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Shift))
                for cb in self.mousecallbacks:
                    cb(self.mousebuttons, pos, rel, mods)
        except:
            import traceback
            traceback.print_exc()


    def mouseReleased(self, arg, butt):
        """
        You need to add a docstring here ! 
        """
        try:
            evt = arg.get_state()
            button = self._convertOgreButtonToCegui(butt)
            #print button
            cegui.System.getSingleton().injectMouseButtonUp(button)
            #print "Mouse button up",butt
            if butt == OIS.MouseButtonID.MB_Left:
                self.mousebuttons[0] = 0
            if butt == OIS.MouseButtonID.MB_Middle:
                self.mousebuttons[1] = 0
            if butt == OIS.MouseButtonID.MB_Right:
                self.mousebuttons[2] = 0
            #print "Up!",self.mousebuttons
            if len(self.mousecallbacks):
                pos = (evt.X.abs, evt.Y.abs, evt.Z.abs)
                rel = (evt.X.rel, evt.Y.rel, evt.Z.rel)
                mods = (self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Ctrl), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Alt), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Shift))
                for cb in self.mousecallbacks:
                    cb(self.mousebuttons, pos, rel, mods)
        except:
            import traceback
            traceback.print_exc()


    def mouseClicked(self, evt):
        """
        You need to add a docstring here ! 
        """
        pass


    def mouseEntered(self, evt):
        """
        You need to add a docstring here ! 
        """
        pass


    def mouseExited(self, evt):
        """
        You need to add a docstring here ! 
        """
        pass


    def mouseMoved(self, arg):
        """
        You need to add a docstring here ! 
        """
        try:
            evt = arg.get_state()
            #print dir(self.renderer.Keyboard)
            #print "Mouse moved!"
            #print dir(arg)
            if len(self.mousecallbacks):
                pos = (evt.X.abs, evt.Y.abs, evt.Z.abs)
                rel = (evt.X.rel, evt.Y.rel, evt.Z.rel)
                mods = (self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Ctrl), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Alt), 
                    self.renderer.Keyboard.isModifierDown(OIS.Keyboard.Shift))
                #mods=(arg.isControlDown(),arg.altDown,arg.shiftDown)
                for cb in self.mousecallbacks:
                    cb(self.mousebuttons, pos, rel, mods)
            #system = cegui.System.getSingleton()
            #renderer = system.renderer
            self.system.getSingleton().injectMouseMove( arg.get_state().X.rel, arg.get_state().Y.rel )
        except:
            import traceback
            traceback.print_exc()


    # Called First
    def keyPressed(self, evt):
        """
        You need to add a docstring here ! 
        """
        try:
            #evt=arg.get_state()
            # init repeat key timing ---------------------
            self.repeatkeyPressed = True
            self.keyTime = 0.0
            self.keyDelay = self.initialdelay
            #print "Key Pressed Time",evt.key,self.keytime
            if evt.key == OIS.KC_ESCAPE:
                reactor.stop()
            if evt.key == OIS.KC_SYSRQ:
                dr = os.listdir('.')
                dat = Date().now()
                x = 0
                path = 'screenshot_%s%02d.png' % (dat.format("%Y%m%d"), x)
                while path in dr:
                    path = 'screenshot_%s%02d.png' % (dat.format("%Y%m%d"), x)
                    x += 1
                self.numScreenShots += 1
                self.renderer.renderWindow.writeContentsToFile(path)
            system = cegui.System.getSingleton()
            system.injectKeyDown(evt.key)
            system.injectChar(evt.text)
            # broken in Python-Ogre
            if not self.system.getGUISheet().getActiveChild() or \
                not "Editbox" in self.system.getGUISheet().getActiveChild().getType().c_str():
                if self.keycallbacks.has_key(evt.key):
                    self.keycallbacks[evt.key](1)
            # store our repeat key ---------------------
            #self.key = evt.key
            #self.keyChar = evt.keyChar
            #print dir(evt)
            #evt.consume()
        except:
            import traceback
            traceback.print_exc()


    # Called Second
    def keyReleased(self, evt):
        """
        You need to add a docstring here ! 
        """
        try:
            #evt=arg.get_state()
            # disable repeat key ---------------------
            self.repeatkeyPressed = False
            #print "Key Released Time",evt.key,self.keyTime
            system = cegui.System.getSingleton()
            system.injectKeyUp(evt.key)
            #if not "Editbox" in self.system.guiSheet.activeChild.type:
            if not self.system.getGUISheet().getActiveChild() or \
                not "Editbox" in self.system.getGUISheet().getActiveChild().getType().c_str():
                if self.keycallbacks.has_key(evt.key):
                    self.keycallbacks[evt.key](0)
        except:
            import traceback
            traceback.print_exc()


    # Called Last
    def keyClicked(self, evt):
        """
        You need to add a docstring here ! 
        """
        pass


    def _convertOgreButtonToCegui(self, buttonID):
        """
        You need to add a docstring here ! 
        """
        # Convert ogre button to cegui button
        if buttonID == 0:
            return cegui.LeftButton
        elif buttonID == 1:
            return cegui.RightButton
        elif buttonID == 2:
            return cegui.MiddleButton
        elif buttonID == 3:
            return cegui.X1Button
        else:
            return cegui.LeftButton


    def loadLayout(self, file, place):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        return cegui.WindowManager.getSingleton().loadWindowLayout(file, place)


    def createComponent(self, widget_name, name, pos,
            size, min=(0.01, 0.01), max=(1.0, 1.0), text='',
            showframe=False):
        """
        Manually create a component ! 
        """
        if self.disabled:
            return 0
        control = cegui.WindowManager.getSingleton().createWindow(widget_name, name)
        control.position = cegui.UVector2(cegui.UDim(pos[0], 0), cegui.UDim(pos[1], 0))
        control.setSize(cegui.UVector2(cegui.UDim(size[0], 0), cegui.UDim(size[1], 0)))
        #control.setMinimumSize( cegui.UVector2(cegui.UDim(min[0],-1),cegui.UDim(min[1],-1)))
        #control.setMaximumSize( cegui.UVector2(cegui.UDim(max[0],-1),cegui.UDim(max[1],-1)) )
        control.setText( text)
        control.frameEnabled = showframe
        return control


    def getTopWindow(self):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        return self.system.guiSheet


    def displayWindow(self, w):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            #print "I'm disabled"
            return 0
        self.system.getGUISheet().addChildWindow(w)


    def hideWindow(self, w):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            #print "I'm disabled"
            return 0
        #print "Hiding",w
        self.system.getGUISheet().removeChildWindow(w)


    def getComponent(self, name):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        return cegui.WindowManager.getSingleton().getWindow(name)


    def requestUICallback(self, comp, type, cb, f=""):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        if isinstance(comp, str):
            comp = self.getComponent(comp)
        ev = getattr(comp, type)
        #print "Registering-- ",comp,ev,ev.c_str()
        uicb = UICallback(cb, f)
        uicb.subscribe(comp, ev)
        ref = "%s-%s-%s.%s" % (comp.name.c_str(), type, cb, f)
        #print "Adding callback",ref
        self.uicallbacks[ref] = uicb
        #sub=comp.subscribeEvent(type, cb,f)
        #print sub
        return ref


    def stopUICallback(self, cb):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            #print "Disabled"
            return 0
        if not cb in self.uicallbacks.keys():
            # print "unknown callback", cb
            return 0
        reactor.callLater(0.01, self._stopUICallback, cb)


    def _stopUICallback(self, cb):
        """
        You need to add a docstring here ! 
        """
        if not cb in self.uicallbacks.keys():
            # print "*Unknown callback", cb
            return
        self.uicallbacks[cb].unsubscribe()
        #print "Removed callback",cb,self.uicallbacks[cb]
        del self.uicallbacks[cb]


    def requestKeyCallback(self, key, cb):
        """
        You need to add a docstring here ! 
        """
        self.keycallbacks[key] = cb


    def stopKeyCallback(self, key):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        del self.keycallbacks[key]


    def requestMouseCallback(self, cb):
        """
        Register a mouse callback with the system.
            cb will be called if the mouse moves or is
            clicked. cb should accept two args.
                Arg 1: (b1,b2,b3) shows the state of 3 mouse buttons
                Arg 2: (x,y,z) shows, the absolute position of the mouse.
        """
        self.mousecallbacks.append(cb)


    def stopMouseCallback(self, cb):
        """
        You need to add a docstring here ! 
        """
        if cb in self.mousecallbacks:
            self.mousecallbacks.remove(cb)
            return 1
        return 0


    def addItemToListBox(self, l, t):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        #print "Adding",l,"item",t,l.itemCount+1
        item = cegui.ListboxTextItem(t, l.itemCount + 1)
        #item.setId(l.getItemCount())
        item.setSelectionBrushImage( "TaharezLook", "ListboxSelectionBrush")
        item.setSelectionColours (cegui.colour(1.0, 0.0, 0.0, 1.0))
        item.setTextColours (cegui.colour(0.0, 0.0, 1.0, 1.0))
        item.AutoDeleted = False
        l.addItem(item)
        return item


    def addRowToListBox(self, multi, cols):
        """
        You need to add a docstring here ! 
        """
        if self.disabled:
            return 0
        r = []
        for c in cols:
            # Add items to the MultiCoulumList
            item = cegui.ListboxTextItem(str(c))
            item.setSelectionBrushImage( "TaharezLook", "ListboxSelectionBrush")
            item.setSelectionColours(cegui.colour(1.0, 0.0, 0.0, 1.0))
            item.setTextColours(cegui.colour(0.0, 0.0, 1.0, 1.0))
            item.AutoDeleted = False
            if cols.index(c) == 0:
                row = multi.addRow(item, 0)
            else:
                multi.setItem(item, cols.index(c), row)
            # you must hold a copy of this so it isn't destroyed while CEGUI uses it
            r.append(item)
            r.append(row)
        return r


    def createImageSet(self, name, image):
        """
        You need to add a docstring here ! 
        """
        try:
            if not cegui.ImagesetManager.getSingleton().isImagesetPresent(name):
                #self.renderer.loadImage(image)
                cegui.ImagesetManager.getSingleton().createImagesetFromImageFile(name, image)
        except:
            import traceback
            traceback.print_exc()


    def setButtonImages(self, btn, norm, hover, pushed):
        """
        You need to add a docstring here ! 
        """
        try:
            self.createImageSet(norm, norm)
            self.createImageSet(hover, hover)
            self.createImageSet(pushed, pushed)
            btn.setProperty("NormalImage", "set: %s image: full_image" %norm)
            btn.setProperty("HoverImage", "set: %s image: full_image" % hover)
            btn.setProperty("PushedImage", "set: %s image: full_image" %pushed)
        except:
            import traceback
            traceback.print_exc()


    def setBackgroundImage(self, image):
        """
        You need to add a docstring here ! 
        """
        self.background.setProperty("Image", "set:%s image:full_image" % image)


    def removeBackgroundImage(self):
        """
        You need to add a docstring here ! 
        """
        self.background.setProperty("Image", "set:BackgroundImage image:full_image")



loadedmsg = 0
loadedque = 0



class UserInterface:
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui):
        """
        You need to add a docstring here ! 
        """
        self.ui = ui


    def finalize(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def iterate(self, time):
        """
        You need to add a docstring here ! 
        """
        pass


    def start(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        pass



def QuickMessage(ui, message, title="", button="Ok"):
    """
    You need to add a docstring here ! 
    """
    m = MessageWindow()
    m.initialize(ui, message, title, button)
    return m.start()



def QuickQuestion(ui, message, title="", buttons=["No", "Yes"]):
    """
    You need to add a docstring here ! 
    """
    m = QuestionWindow()
    m.initialize(ui, message, title, buttons)
    return m.start()



class MessageWindow(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, message, title="", button="Ok"):
        """
        You need to add a docstring here ! 
        """
        global loadedmsg
        self.ui = ui
        if not loadedmsg:
            ui.loadLayout("MessageWindow.layout", "")
            loadedmsg = 1
        self.window = ui.getComponent("MessageWindow")
        self.window.text = title
        self.ok = ui.getComponent("MessageWindow/Ok")
        self.ok.text = button
        ui.getComponent("MessageWindow/Message").text = Wrap(str(message))


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.window)
        self.okcb = self.ui.requestUICallback("MessageWindow/Ok", "EventClicked", self, "okPressed")
        self.d = defer.Deferred()
        return self.d


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.okcb)


    def okPressed(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.d.callback(1)
            self.stop()
        except:
            print "Problem with Ok"



def Wrap(message, maxwidth=30):
    """
    You need to add a docstring here ! 
    """
    s = message.split(" ")
    lines = ""
    gg = ""
    for ss in s:
        if len(gg) + len(ss) > maxwidth:
            if lines != "":
                lines += "\n"
            lines += gg
            gg = ""
        gg += ss + " "
    lines += gg
    return lines



class QuestionWindow(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, message, title="", buttons=["No", "Yes"]):
        """
        You need to add a docstring here ! 
        """
        global loadedque
        self.ui = ui
        if not loadedque:
            ui.loadLayout("QuestionWindow.layout", "")
            loadedque = 1
        self.window = ui.getComponent("QuestionWindow")
        self.window.text = title
        self.no = ui.getComponent("QuestionWindow/No")
        self.no.text = buttons[0]
        self.yes = ui.getComponent("QuestionWindow/Yes")
        self.yes.text = buttons[1]
        ui.getComponent("QuestionWindow/Message").text = Wrap(str(message))


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.window)
        self.yescb = self.ui.requestUICallback("QuestionWindow/Yes", "EventClicked", self, "yes")
        self.nocb = self.ui.requestUICallback("QuestionWindow/No", "EventClicked", self, "no")
        self.d = defer.Deferred()
        return self.d


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.yescb)
        self.ui.stopUICallback(self.nocb)


    def yes(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.d.callback(1)
            self.stop()
        except:
            print "Problem with Ok"


    def no(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.d.callback(0)
            self.stop()
        except:
            print "Problem with No"
