# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
Asset Selector Interface .. 
"""

from twisted.internet import defer

from ogre.gui import CEGUI as cegui

from mv3d.client.ui.cegui import UserInterface
from mv3d.util import parseInstanceId


uiloaded = 0

class AssetSelector(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, pi):
        """
        You need to add a docstring here ! 
        """
        global uiloaded
        self.ui = ui
        self.plugin = pi
        if uiloaded == 0:
            uiloaded = 1
            w = self.ui.createComponent("WindowsLook/FrameWindow", 
                "AssetSelectorWindow", [0.25, 0.3], [0.5, 0.5], [0.01, 0.01], 
                [1.0, 1.0], "Select Asset")
            agid = self.ui.createComponent("WindowsLook/Combobox", 
                "AssetSelectorWindow/AGIDText", [0.0, 0.1], [1.0, 0.8], [0.01, 0.01], 
                [1.0, 1.0], "")
            #agnm=self.ui.createComponent("WindowsLook/StaticText",
                #"AssetSelectorWindow/AGNMText",[0.2,0.1],[0.8,0.1],[0.01,0.01],
                #[1.0,1.0],"")
            alist = ui.createComponent("WindowsLook/MultiColumnList", 
                "AssetSelectorWindow/AssetList", [0.1, 0.2], [0.8, 0.5], [0.01, 0.01], [1.0, 1.0], '')
            alist.addColumn('ID', 0, cegui.UDim(0.15, 0))   #name, id, width ( % widget)
            alist.addColumn('Name', 1, cegui.UDim(0.5, 0))   #name, id, width ( % widget)
            alist.addColumn('Type', 2, cegui.UDim(0.6, 0))   #name, id, width ( % widget)
            alist.showVertScrollbar = True
            aid = ui.createComponent("WindowsLook/Editbox", 
                "AssetSelectorWindow/AIDText", [0.0, 0.7], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], '')
            anm = ui.createComponent("WindowsLook/StaticText", 
                "AssetSelectorWindow/ANMText", [0.2, 0.7], [0.8, 0.1], [0.01, 0.01], [1.0, 1.0], '')
            aty = ui.createComponent("WindowsLook/Combobox", 
                "AssetSelectorWindow/ATYText", [0.2, 0.8], [0.8, 0.4], [0.01, 0.01], [1.0, 1.0], '')
            atyx = ui.createComponent("WindowsLook/StaticText", 
                "AssetSelectorWindow/ATYXText", [0.0, 0.8], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Type')
            cbtn = ui.createComponent("WindowsLook/Button", 
                "AssetSelectorWindow/CButton", [0.6, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Cancel')
            sbtn = ui.createComponent("WindowsLook/Button", 
                "AssetSelectorWindow/SButton", [0.8, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Select')
            w.addChildWindow(agid)
            #w.addChildWindow(agnm)
            w.addChildWindow(alist)
            w.addChildWindow(aid)
            w.addChildWindow(anm)
            w.addChildWindow(aty)
            w.addChildWindow(atyx)
            w.addChildWindow(cbtn)
            w.addChildWindow(sbtn)
        self.window = self.ui.getComponent("AssetSelectorWindow")
        self.selgrp = 0
        self.assettypes = []





    def SetAssetTypes(self, at):
        """
        You need to add a docstring here ! 
        """
        # print at
        #return
        self.assettypes = at


    def finalize(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def start(self):
        """
        You need to add a docstring here ! 
        """
        # print "Start"
        self.ui.displayWindow(self.window)
        self.scb = self.ui.requestUICallback("AssetSelectorWindow/SButton", "EventClicked", self, "Selected")
        self.ccb = self.ui.requestUICallback("AssetSelectorWindow", "EventCloseClicked", self, "Closed")
        self.alc = self.ui.requestUICallback("AssetSelectorWindow/AssetList", "EventSelectionChanged", self, "UpdateSelection")
        d = self.plugin.callRemote("ListAssetGroups")
        d.addCallback(self.GotAssetGroups)
        self.deferred = defer.Deferred()
        # print "Started"
        return self.deferred


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.stopUICallback(self.scb)
        self.ui.hideWindow(self.window)


    def Closed(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            if not self.deferred.called:
                self.deferred.callback(0)
            self.stop()
        except:
            import traceback
            traceback.print_exc()


    def GotAssetGroups(self, ag):
        """
        You need to add a docstring here ! 
        """
        # print "GotAsset Groups"
        box = self.ui.getComponent("AssetSelectorWindow/AGIDText")
        box.resetList()
        self.agidv = []
        for g in ag:
            self.agidv.append(self.ui.addItemToListBox(box, "%s: %s" % (g[0], g[1])))
        d = self.plugin.callRemote("ListAssets", self.selgrp, 
            self.assettypes)
        d.addCallback(self.GotAssets)


    def GotAssets(self, assets):
        """
        You need to add a docstring here ! 
        """
        # print "Got Assets"
        box = self.ui.getComponent("AssetSelectorWindow/AssetList")
        box.resetList()
        self.aslst = []
        # print "Got",assets
        for a in assets:
            self.aslst.append(self.ui.addRowToListBox(box, [str(a[0]), str(a[1]), str(a[2])]))


    def Selected(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.stop()
            tid = self.ui.getComponent("AssetSelectorWindow/AIDText").text.c_str()
            aid = parseInstanceId(tid)
            #print aid
            self.deferred.callback(aid)
        except:
            import traceback
            traceback.print_exc()


    def UpdateSelection(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            box = self.ui.getComponent("AssetSelectorWindow/AssetList")
            iid = box.getFirstSelectedItem().text
            inm = box.getNextSelected(box.getFirstSelectedItem()).text.c_str()
            #print sel,inm
            self.ui.getComponent("AssetSelectorWindow/AIDText").text = iid
            self.ui.getComponent("AssetSelectorWindow/ANMText").text = inm
        except:
            import traceback
            traceback.print_exc()
