# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
IGE plugin for moving objects
"""


from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.util import math3d as VectorMath

uiloaded = 0


class MoveObject(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "Move Object"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Object"


    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        global uiloaded
        self.ui = ui
        self.ige = ige
        self.plugin = pi
        self.mousedown = 0
        self.tofs = 0
        # creeate the ui
        if uiloaded == 0:
            uiloaded = 1
            w = self.ui.createComponent("WindowsLook/FrameWindow", 
                "MoveObjectWindow", [0.5, 0.0], [0.5, 0.08], [0.01, 0.01], [1.0, 1.0], "Move")
            ab = self.ui.createComponent("WindowsLook/Button", 
                "MoveObjectWindow/AbsButton", [0.0, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Abs")
            rb = self.ui.createComponent("WindowsLook/Button", 
                "MoveObjectWindow/RelButton", [0.08, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Rel")
            xt = self.ui.createComponent("WindowsLook/Editbox", 
                "MoveObjectWindow/XEdit", [0.16, 0.25], [0.20, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            yt = self.ui.createComponent("WindowsLook/Editbox", 
                "MoveObjectWindow/YEdit", [0.36, 0.25], [0.20, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            zt = self.ui.createComponent("WindowsLook/Editbox", 
                "MoveObjectWindow/ZEdit", [0.56, 0.25], [0.20, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            cb = self.ui.createComponent("WindowsLook/Button", 
                "MoveObjectWindow/ClrButton", [0.76, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Clr")
            ub = self.ui.createComponent("WindowsLook/Button", 
                "MoveObjectWindow/UpdButton", [0.84, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Upd")
            w.addChildWindow(ab)
            w.addChildWindow(rb)
            w.addChildWindow(xt)
            w.addChildWindow(yt)
            w.addChildWindow(zt)
            w.addChildWindow(cb)
            w.addChildWindow(ub)
        self.window = self.ui.getComponent("MoveObjectWindow")


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "MoveButtonN.png", "MoveButtonH.png", "MoveButtonA.png")
        par.addChildWindow(c)
        return c


    def start(self):
        """
        You need to add a docstring here ! 
        """
        # print "---- STARTING MOVE ----"
        self.ui.requestMouseCallback(self.GotMouse)
        self.ui.displayWindow(self.window)
        self.cbcb = self.ui.requestUICallback("MoveObjectWindow", "EventCloseClicked", self, "Stop")
        self.abcb = self.ui.requestUICallback("MoveObjectWindow/AbsButton", "EventClicked", self, "MoveAbs")
        self.rbcb = self.ui.requestUICallback("MoveObjectWindow/RelButton", "EventClicked", self, "MoveRel")
        self.lbcb = self.ui.requestUICallback("MoveObjectWindow/ClrButton", "EventClicked", self, "Clear")
        self.ubcb = self.ui.requestUICallback("MoveObjectWindow/UpdButton", "EventClicked", self, "Update")
        sel = self.ige.GetSelection()
        if len(sel) != 0:
            o = self.ui.client.getInterface("Simulation Client").getItem(sel[0])
            spos = o.getPosition()
        else:
            spos = (0.0, 0.0, 0.0)
        self.ui.getComponent("MoveObjectWindow/XEdit").text = str(spos[0])
        self.ui.getComponent("MoveObjectWindow/YEdit").text = str(spos[1])
        self.ui.getComponent("MoveObjectWindow/ZEdit").text = str(spos[2])


    def stop(self, args=0):
        """
        You need to add a docstring here ! 
        """
        # print "---- STOPPING MOVE ----"
        self.ui.stopMouseCallback(self.GotMouse)
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.cbcb)
        self.ui.stopUICallback(self.abcb)
        self.ui.stopUICallback(self.rbcb)


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            import traceback
            traceback.print_exc()


    def Clear(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.ui.getComponent("MoveObjectWindow/XEdit").text = "0.0"
            self.ui.getComponent("MoveObjectWindow/YEdit").text = "0.0"
            self.ui.getComponent("MoveObjectWindow/ZEdit").text = "0.0"
        except:
            import traceback
            traceback.print_exc()


    def Update(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            if len(sel) != 0:
                o = self.ui.client.getInterface("Simulation Client").getItem(sel[0])
                spos = o.getPosition()
            else:
                spos = (0.0, 0.0, 0.0)
            self.ui.getComponent("MoveObjectWindow/XEdit").text = str(spos[0])
            self.ui.getComponent("MoveObjectWindow/YEdit").text = str(spos[1])
            self.ui.getComponent("MoveObjectWindow/ZEdit").text = str(spos[2])
        except:
            import traceback
            traceback.print_exc()


    def MoveAbs(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            x = float(self.ui.getComponent("MoveObjectWindow/XEdit").text.c_str())
            y = float(self.ui.getComponent("MoveObjectWindow/YEdit").text.c_str())
            z = float(self.ui.getComponent("MoveObjectWindow/ZEdit").text.c_str())
            self.plugin.callRemote("setPosition", sel, (x, y, z))
            self.UpdateItems((x,y,z), 0)
        except:
            import traceback
            traceback.print_exc()


    def MoveRel(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            x = float(self.ui.getComponent("MoveObjectWindow/XEdit").text.c_str())
            y = float(self.ui.getComponent("MoveObjectWindow/YEdit").text.c_str())
            z = float(self.ui.getComponent("MoveObjectWindow/ZEdit").text.c_str())
            self.ui.getComponent("MoveObjectWindow/XEdit").text = "0.0"
            self.ui.getComponent("MoveObjectWindow/YEdit").text = "0.0"
            self.ui.getComponent("MoveObjectWindow/ZEdit").text = "0.0"
            self.plugin.callRemote("setPositionRel", sel, (x, y, z))
            self.UpdateItems((x,y,z), 1)
        except:
            import traceback
            traceback.print_exc()


    def GotMouse(self, btn, pos, rel, mods):
        """
        You need to add a docstring here ! 
        """
        try:
            # we got a mouse event!
            if btn[0]:
                if not self.mousedown:
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "Background")
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            if hasattr(o, "disableUpdates"):
                                o.disableUpdates()
                                self.op = o.getPosition()
                self.mousedown = 1
                #self.tofs=(0,0,0)
            if btn[1]:
                if not self.mousedown:
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "Background")
                    #self.ui.system.defaultMouseCursor = "WindowsLook", "Background"
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            if hasattr(o, "disableUpdates"):
                                o.disableUpdates()
                                self.op = o.getPosition()
                self.mousedown = 2
                #self.tofs=(0,0,0)
            if btn[2]:
                self.ui.system.setDefaultMouseCursor("WindowsLook", "MouseArrow")
                #self.ui.system.defaultMouseCursor = "WindowsLook", "MouseArrow"
                self.stop()
                self.tofs = (0, 0, 0)
                return
            if not btn[0] and not btn[1]:
                if self.mousedown:
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            if hasattr(o, "enableUpdates"):
                                o.enableUpdates()
                            #print "Roffs = ", VectorMath.subtractVectors(self.op, o.getPosition())
                            #print "toffs = ", self.tofs
                            self.plugin.callRemote("setPosition", [oid], o.getPosition())
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "MouseArrow")
                    #self.ui.system.defaultMouseCursor = "WindowsLook", "MouseArrow"
                    sel = self.ige.GetSelection()
                    #for o in sel:
                #self.plugin.callRemote("setPositionRel",sel,self.tofs)
                self.mousedown = 0
                self.tofs = (0, 0, 0)
                return
            sel = self.ige.GetSelection()
            ss = self.ui.renderer.getScreenDimensions()
            if self.mousedown == 1:
                oco = self.ui.renderer.camera.orientation
                co = (oco.w, oco.x, oco.y, oco.z)
                mo = 1
                offs = VectorMath.rotateVector((mo * rel[0],  - mo * rel[1], mo * rel[2]), co)
                #print offs
                self.tofs = VectorMath.addVectors(self.tofs, offs)
                #self.plugin.callRemote("setPositionRel",sel,offs)
                self.UpdateItems(offs, 1)
            if self.mousedown == 2:
                oco = self.ui.renderer.camera.orientation
                co = (oco.w, oco.x, oco.y, oco.z)
                mo = 1
                offs = VectorMath.rotateVector((mo * rel[0], mo * rel[2], mo * rel[1]), co)
                self.tofs = VectorMath.addVectors(self.tofs, offs)
                #print offs
                #self.plugin.callRemote("setPositionRel",sel,offs)
                self.UpdateItems(offs, 1)
        except:
            import traceback
            traceback.print_exc()


    def UpdateItems(self, offs, rel):
        """
        You need to add a docstring here ! 
        """
        sel = self.ige.GetSelection()
        #if rel:
            #print offs
            #self.plugin.callRemote("setPositionRel",sel,offs)
        #else:
            #self.plugin.callRemote("setPosition",sel,offs)
        for oid in sel:
            o = self.ui.client.getInterface("Simulation Client").getItem(oid)
            if o:
                if hasattr(o, "setPosition"):
                    if rel:
                        o.setPosition(VectorMath.addVectors(o.getPosition(), offs))
                    else:
                        o.setPosition(offs)
                    #print o.getPosition()
