# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
This contains the class for the IGE (In Game Editor)  
"""


from twisted.internet import defer

from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.util import parseInstanceId


uiloaded = 0

class ObjectSelectBox(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        global uiloaded
        self.ui = ui
        self.ige = ige
        self.plugin = pi
        if not uiloaded:
            uiloaded = 1
            ui.loadLayout("Select.layout", "WorldEditor/")
        self.window = ui.getComponent("WorldEditor/Select")
        self.items = []


    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "ObjectSelectBox"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Select"


    def GetButtonText(self):
        """
        You need to add a docstring here ! 
        """
        return "S"


    def Selected(self, args):
        """
        You need to add a docstring here ! 
        """
        #print "Selected Called!@"
        self.start()


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.window)
        self.scb = self.ui.requestUICallback("WorldEditor/Select/Select", "EventClicked", self, "SelectHit")
        self.ccb = self.ui.requestUICallback("WorldEditor/Select", "EventCloseClicked", self, "CloseHit")
        self.FillList()
        self.deferred = defer.Deferred()
        return self.deferred


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.hideWindow(self.window)
        self.ui.getComponent("WorldEditor/Select/List").resetList()
        self.items = []
        self.ui.stopUICallback(self.scb)
        self.ui.stopUICallback(self.ccb)


    def CloseHit(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            # print "You closed me!"
            self.stop()
            if not self.deferred.called:
                self.deferred.callback(0)
        except:
            import traceback
            traceback.print_exc()


    def FillList(self):
        """
        You need to add a docstring here ! 
        """
        d = self.plugin.callRemote("getObjects", (0, 0))
        d.addCallback(self.FillList_GotList)
        d.addErrback(self.ui.client.Error)


    def FillList_GotList(self, r):
        """
        You need to add a docstring here ! 
        """
        lb = self.ui.getComponent("WorldEditor/Select/List")
        lb.resetList()
        self.items = []
        if len(r.keys()):
            k = r.keys()[0]
            lb.text = "%s: %s" % (str(k), r[k])
        for k, v in r.items():
            self.items.append(self.ui.addItemToListBox(lb, "%s: %s" % (str(k), v)))


    def SelectHit(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            #print "Getting comp"
            lb = self.ui.getComponent("WorldEditor/Select/List")
            #print "checking comp select"
            if lb.selectedCount == 0:
                if not self.deferred.called:
                    self.deferred.callback(0)
                self.stop()
                return 
            #print "Getting selected item"
            tt = lb.getFirstSelectedItem().text
            #print "Splitting"
            s = tt.split(":")
            #print "Parsing",s
            val = parseInstanceId(s[0])
            self.ige.SetParam("itemselection", [val])
            #print "You selected",val
            self.stop()
            #print "stopped"
            if not self.deferred.called:
                self.deferred.callback(val)
            #print "called back"
        except:
            # print "SELECT ERROR"
            import traceback
            traceback.print_exp()
