# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
This contains the class for the IGE (In Game Editor)  
"""


from twisted.internet import defer

from mv3d.util import parseInstanceId
from mv3d.util.classgen import ClassGenerator
from mv3d.client.ui.cegui import UserInterface


uiloaded = 0


class BoxProperties(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, i, ige):
        """
        You need to add a docstring here ! 
        """
        try:
            global uiloaded
            self.ui = ui
            self.interface = i
            self.ige = ige
            if not uiloaded:
                uiloaded = 1
                w = self.ui.createComponent("WindowsLook/FrameWindow", 
                    "BoxProperties", [0.25, 0.3], [0.5, 0.5], [0.01, 0.01], 
                    [1.0, 1.0], "Item Properties")
                iidl = ui.createComponent("WindowsLook/StaticText", 
                    "BoxProperties/IIDLText", [0.1, 0.1], [0.3, 0.1], [0.01, 0.01], [1.0, 1.0], 'ID:')
                iid = ui.createComponent("WindowsLook/StaticText", 
                    "BoxProperties/IIDText", [0.4, 0.1], [0.4, 0.1], [0.01, 0.01], [1.0, 1.0], '')
                nml = ui.createComponent("WindowsLook/StaticText", 
                    "BoxProperties/NMLText", [0.1, 0.2], [0.3, 0.1], [0.01, 0.01], [1.0, 1.0], 'Name:')
                nme = ui.createComponent("WindowsLook/Editbox", 
                    "BoxProperties/NMEEdit", [0.4, 0.2], [0.4, 0.1], [0.01, 0.01], [1.0, 1.0], '')
                asl = ui.createComponent("WindowsLook/StaticText", 
                    "BoxProperties/ASLText", [0.1, 0.3], [0.3, 0.1], [0.01, 0.01], [1.0, 1.0], 'Model:')
                ast = ui.createComponent("WindowsLook/Editbox", 
                    "BoxProperties/ASText", [0.4, 0.3], [0.4, 0.1], [0.01, 0.01], [1.0, 1.0], '')
                asbt = ui.createComponent("WindowsLook/Button", 
                    "BoxProperties/ASButton", [0.8, 0.3], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Select')
                cbtn = ui.createComponent("WindowsLook/Button", 
                    "BoxProperties/CButton", [0.4, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Cancel')
                abtn = ui.createComponent("WindowsLook/Button", 
                    "BoxProperties/AButton", [0.8, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Apply')
                okbtn = ui.createComponent("WindowsLook/Button", 
                    "BoxProperties/OKButton", [0.6, 0.9], [0.2, 0.1], [0.01, 0.01], [1.0, 1.0], 'Ok')
                w.addChildWindow(iidl)
                w.addChildWindow(iid)
                w.addChildWindow(nml)
                w.addChildWindow(nme)
                w.addChildWindow(asl)
                w.addChildWindow(ast)
                w.addChildWindow(asbt)
                w.addChildWindow(cbtn)
                w.addChildWindow(abtn)
                w.addChildWindow(okbtn)
            self.window = self.ui.getComponent("BoxProperties")
            self.deferred = 0
        except:
            import traceback
            traceback.print_exc()


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.window)
        # print "i am a ",self
        self.sacb = self.ui.requestUICallback("BoxProperties/ASButton", "EventClicked", self, "SelectAsset")
        self.ccb = self.ui.requestUICallback("BoxProperties/CButton", "EventClicked", self, "Cancel")
        self.acb = self.ui.requestUICallback("BoxProperties/AButton", "EventClicked", self, "Apply")
        self.ocb = self.ui.requestUICallback("BoxProperties/OKButton", "EventClicked", self, "Ok")
        d = self.interface.callRemote("GetInfo")
        d.addCallback(self.GotInfo)
        # print "Box started!"
        return d


    def GotInfo(self, inf):
        """
        You need to add a docstring here ! 
        """
        self.ui.getComponent("BoxProperties/IIDText").text = str(inf[0])
        self.ui.getComponent("BoxProperties/NMEEdit").text = inf[1]
        self.ui.getComponent("BoxProperties/ASText").text = str(inf[2])
        self.deferred = defer.Deferred()
        return self.deferred


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        # print "stopping"
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.sacb)
        self.ui.stopUICallback(self.ccb)
        self.ui.stopUICallback(self.acb)
        self.ui.stopUICallback(self.ocb)


    def SelectAsset(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            #print "select hit"
            d = self.ige.getAssetSelector()
            d.addCallback(self.SelectAsset_GotSelector)
        except:
            import traceback
            traceback.print_exc()


    def SelectAsset_GotSelector(self, asa):
        """
        You need to add a docstring here ! 
        """
        # print "Got selector"
        asa.SetAssetTypes([ClassGenerator(modulename = "mv3d.resource.asset", classname = "MeshAsset")])
        d = asa.start()
        d.addCallback(self.SelectAsset_Selected)
        # print "Started"


    def SelectAsset_Selected(self, asset):
        """
        You need to add a docstring here ! 
        """
        self.ui.getComponent("BoxProperties/ASText").text = str(asset)


    def Cancel(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.stop()
            if self.deferred != 0:
                self.deferred.callback(0)
        except:
            import traceback
            traceback.print_exc()


    def Apply(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            nm = self.ui.getComponent("BoxProperties/NMEEdit").text.c_str()
            self.interface.callRemote("setName", nm)
            aid = self.ui.getComponent("BoxProperties/ASText").text.c_str()
            self.interface.callRemote("SetAsset", parseInstanceId(aid))
        except:
            import traceback
            traceback.print_exc()


    def Ok(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            nm = self.ui.getComponent("BoxProperties/NMEEdit").text.c_str()
            self.interface.callRemote("setName", nm)
            aid = self.ui.getComponent("BoxProperties/ASText").text.c_str()
            self.interface.callRemote("SetAsset", parseInstanceId(aid))
            self.stop()
            if self.deferred != 0:
                self.deferred.callback(1)
        except:
            import traceback
            traceback.print_exc()
