# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
IGE plugin for moving objects
"""

from ogre.renderer import OGRE

from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.util import math3d as VectorMath


uiloaded = 0

class RotateObject(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "Rotate Object"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Object"


    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        global uiloaded
        self.ui = ui
        self.ige = ige
        self.plugin = pi
        self.mousedown = 0
        self.toffs = (0, 0, 0)
        # creeate the ui
        if uiloaded == 0:
            uiloaded = 1
            w = self.ui.createComponent("WindowsLook/FrameWindow", 
                "RotateObjectWindow", [0.5, 0.0], [0.5, 0.08], [0.01, 0.01], [1.0, 1.0], "Rotate")
            ab = self.ui.createComponent("WindowsLook/Button", 
                "RotateObjectWindow/AbsButton", [0.0, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Abs")
            rb = self.ui.createComponent("WindowsLook/Button", 
                "RotateObjectWindow/RelButton", [0.08, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Rel")
            wt = self.ui.createComponent("WindowsLook/Editbox", 
                "RotateObjectWindow/WEdit", [0.16, 0.25], [0.15, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            xt = self.ui.createComponent("WindowsLook/Editbox", 
                "RotateObjectWindow/XEdit", [0.31, 0.25], [0.15, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            yt = self.ui.createComponent("WindowsLook/Editbox", 
                "RotateObjectWindow/YEdit", [0.46, 0.25], [0.15, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            zt = self.ui.createComponent("WindowsLook/Editbox", 
                "RotateObjectWindow/ZEdit", [0.61, 0.25], [0.15, 1.0], [0.01, 0.01], [1.0, 1.0], "")
            cb = self.ui.createComponent("WindowsLook/Button", 
                "RotateObjectWindow/ClrButton", [0.76, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Clr")
            ub = self.ui.createComponent("WindowsLook/Button", 
                "RotateObjectWindow/UpdButton", [0.84, 0.25], [0.08, 1.0], [0.01, 0.01], [1.0, 1.0], "Upd")
            w.addChildWindow(ab)
            w.addChildWindow(rb)
            w.addChildWindow(wt)
            w.addChildWindow(xt)
            w.addChildWindow(yt)
            w.addChildWindow(zt)
            w.addChildWindow(cb)
            w.addChildWindow(ub)
        self.window = self.ui.getComponent("RotateObjectWindow")
        # print 8


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "RotateButtonN.png", "RotateButtonH.png", "RotateButtonA.png")
        par.addChildWindow(c)
        return c


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.requestMouseCallback(self.GotMouse)
        self.ui.displayWindow(self.window)
        self.cbcb = self.ui.requestUICallback("RotateObjectWindow", "EventCloseClicked", self, "Stop")
        self.abcb = self.ui.requestUICallback("RotateObjectWindow/AbsButton", "EventClicked", self, "MoveAbs")
        self.rbcb = self.ui.requestUICallback("RotateObjectWindow/RelButton", "EventClicked", self, "MoveRel")
        self.lbcb = self.ui.requestUICallback("RotateObjectWindow/ClrButton", "EventClicked", self, "Clear")
        self.ubcb = self.ui.requestUICallback("RotateObjectWindow/UpdButton", "EventClicked", self, "Update")
        sel = self.ige.GetSelection()
        if len(sel) != 0:
            o = self.ui.client.getInterface("Simulation Client").getItem(sel[0])
            spos = o.getRotation()
        else:
            spos = (1.0, 0.0, 0.0, 0.0)
        self.ui.getComponent("RotateObjectWindow/WEdit").text = str(spos[0])
        self.ui.getComponent("RotateObjectWindow/XEdit").text = str(spos[1])
        self.ui.getComponent("RotateObjectWindow/YEdit").text = str(spos[2])
        self.ui.getComponent("RotateObjectWindow/ZEdit").text = str(spos[3])


    def stop(self, args=0):
        """
        You need to add a docstring here ! 
        """
        self.ui.stopMouseCallback(self.GotMouse)
        self.ui.hideWindow(self.window)
        self.ui.stopUICallback(self.cbcb)
        self.ui.stopUICallback(self.abcb)
        self.ui.stopUICallback(self.rbcb)


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            import traceback
            traceback.print_exc()


    def Clear(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.ui.getComponent("RotateObjectWindow/WEdit").text = "1.0"
            self.ui.getComponent("RotateObjectWindow/XEdit").text = "0.0"
            self.ui.getComponent("RotateObjectWindow/YEdit").text = "0.0"
            self.ui.getComponent("RotateObjectWindow/ZEdit").text = "0.0"
        except:
            import traceback
            traceback.print_exc()


    def Update(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            if len(sel) != 0:
                o = self.ui.client.getInterface("Simulation Client").getItem(sel[0])
                spos = o.getRotation()
            else:
                spos = (0.0, 0.0, 0.0, 0.0)
            self.ui.getComponent("RotateObjectWindow/WEdit").text = str(spos[0])
            self.ui.getComponent("RotateObjectWindow/XEdit").text = str(spos[1])
            self.ui.getComponent("RotateObjectWindow/YEdit").text = str(spos[2])
            self.ui.getComponent("RotateObjectWindow/ZEdit").text = str(spos[3])
        except:
            import traceback
            traceback.print_exc()


    def MoveAbs(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            w = float(self.ui.getComponent("RotateObjectWindow/WEdit").text.c_str)
            x = float(self.ui.getComponent("RotateObjectWindow/XEdit").text.c_str)
            y = float(self.ui.getComponent("RotateObjectWindow/YEdit").text.c_str)
            z = float(self.ui.getComponent("RotateObjectWindow/ZEdit").text.c_str)
            self.plugin.callRemote("setRotation", sel, (w, x, y, z))
            self.UpdateItems((w, x, y, z), 0)
        except:
            import traceback
            traceback.print_exc()


    def MoveRel(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            sel = self.ige.GetSelection()
            w = float(self.ui.getComponent("RotateObjectWindow/WEdit").text.c_str)
            x = float(self.ui.getComponent("RotateObjectWindow/XEdit").text.c_str)
            y = float(self.ui.getComponent("RotateObjectWindow/YEdit").text.c_str)
            z = float(self.ui.getComponent("RotateObjectWindow/ZEdit").text.c_str)
            self.ui.getComponent("RotateObjectWindow/WEdit").text = "1.0"
            self.ui.getComponent("RotateObjectWindow/XEdit").text = "0.0"
            self.ui.getComponent("RotateObjectWindow/YEdit").text = "0.0"
            self.ui.getComponent("RotateObjectWindow/ZEdit").text = "0.0"
            self.plugin.callRemote("setRotationRel", sel, (w, x, y, z))
            self.UpdateItems((w, x, y, z), 1)
        except:
            import traceback
            traceback.print_exc()


    def GotMouse(self, btn, pos, rel, mods):
        """
        You need to add a docstring here ! 
        """
        try:
            # we got a mouse event!
            if btn[0]:
                if not self.mousedown:
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "Background")
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            if hasattr(o, "disableUpdates"):
                                o.disableUpdates()
                self.mousedown = 1
            if btn[1]:
                if not self.mousedown:
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "Background")
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            if hasattr(o, "disableUpdates"):
                                o.disableUpdates()
                self.mousedown = 2
            if btn[2]:
                self.stop()
                self.toffs = (0, 0, 0)
                return
            if not btn[0] and not btn[1]:
                if self.mousedown:
                    #offs=VectorMath.quaternionFromMatrix(VectorMath.matrixFromEuler(self.toffs))
                    #print "Rotating", offs,self.toffs
                    self.ui.system.setDefaultMouseCursor("WindowsLook", "MouseArrow")
                    for oid in self.ige.GetSelection():
                        o = self.ui.client.getInterface("Simulation Client").getItem(oid)
                        if o:
                            # print "Sending",o.getRotation()
                            self.plugin.callRemote("setRotation", [oid], o.getRotation())
                            if hasattr(o, "disableUpdates"):
                                o.disableUpdates()
                    self.mousedown = 0
                    self.toffs = (0, 0, 0)
                return
            sel = self.ige.GetSelection()
            if self.mousedown == 1:
                offs = VectorMath.matrixFromEuler((rel[0] / 100.0, rel[1] / 100.0, rel[2] / 100.0))
                #~ self.toffs=VectorMath.addVectors((rel[0]/1000.0,rel[1]/1000.0,rel[2]/1000.0),self.toffs)
                #~ print (rel[0]/1000.0, rel[1]/1000.0, rel[2]/1000.0)
                #~ print rel
                #self.plugin.callRemote("setRotationRel",sel,VectorMath.quaternionFromMatrix(offs))
                q = OGRE.Quaternion(offs)
                self.UpdateItems((q.w, q.x, q.y, q.z), 1)
                #~ self.UpdateItems((rel[0]/100.0,rel[1]/100.0,rel[2]/100.0),1)
            if self.mousedown == 2:
                offs = VectorMath.matrixFromEuler((rel[0] / 100.0, rel[2] / 100.0, rel[1] / 100.0))
                #print offs
                #self.plugin.callRemote("setRotationRel",sel,VectorMath.quaternionFromMatrix(offs))
                #~ self.toffs=VectorMath.addVectors((rel[0]/1000.0,rel[2]/1000.0,rel[1]/1000.0),self.toffs)
                q = OGRE.Quaternion(offs)
                self.UpdateItems((q.w, q.x, q.y, q.z), 1)
        except:
            import traceback
            traceback.print_exc()


    def UpdateItems(self, offs, rel):
        """
        You need to add a docstring here ! 
        """
        sel = self.ige.GetSelection()
        #if rel:
            #print offs
            #self.plugin.callRemote("setPositionRel",sel,offs)
        #else:
            #self.plugin.callRemote("setPosition",sel,offs)
        for oid in sel:
            o = self.ui.client.getInterface("Simulation Client").getItem(oid)
            if o:
                if hasattr(o, "setRotation"):
                    if rel:
                        q = OGRE.Quaternion(o.getRotation())
                        q2 = OGRE.Quaternion(offs)
                        #r = q2 * q
                        #q.roll(offs[0])
                        #q.pitch(offs[1])
                        #q.yaw(offs[2])
                        q = q * q2
                        q.normalise()
                        offs2 = (q.w, q.x, q.y, q.z)#VectorMath.multiplyQuaternions(offs, o.getRotation())
                        #print offs2,VectorMath.normalizeQuaternion(offs2)
                        #~ o.setRotation(VectorMath.normalizeQuaternion(offs2))
                        o.setRotation(offs2)
                    else:
                        o.setRotation(VectorMath.normalizeQuaternion(offs))
                    #print o.getPosition()
