# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
This contains the class for the IGE (In Game Editor)
"""
import time

from twisted.internet import defer

from ogre.renderer import OGRE as ogre

from mv3d.util import parseInstanceId
from mv3d.phys.collider import castRay
from mv3d.client.ui.Interfaces.IGE.client import IGEClientPlugin
from mv3d.client.ui.ogre3d import OgreNode
from mv3d.client.ui.ogre3d import OgreObject


uiloaded = 0


class ObjectSelectBox(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        global uiloaded
        self.ui = ui
        self.ige = ige
        self.plugin = pi
        if not uiloaded:
            uiloaded = 1
            ui.loadLayout("Select.layout", "WorldEditor/")
        self.window = ui.getComponent("WorldEditor/Select")
        self.items = []
        self.displayed = 0


    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "ObjectSelectBox"


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Select"


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "SelectByWindowN.png", "SelectByWindowH.png", "SelectByWindowA.png")
        par.addChildWindow(c)
        return c


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            # print "ERRRROR"
            import traceback
            traceback.print_stack()


    def start(self):
        """
        You need to add a docstring here ! 
        """
        # print "Start"
        self.ui.displayWindow(self.window)
        # print "Displayed"
        self.displayed = 1
        self.scb = self.ui.requestUICallback("WorldEditor/Select/Select", "EventClicked", self, "SelectHit")
        self.ccb = self.ui.requestUICallback("WorldEditor/Select", "EventCloseClicked", self, "CloseHit")
        # print "Callbacks"
        self.FillList()
        # print "called fillist"
        self.deferred = defer.Deferred()
        return self.deferred


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        if self.displayed == 0:
            return
        self.ui.getComponent("WorldEditor/Select/List").resetList()
        self.ui.hideWindow(self.window)
        self.items = []
        self.ui.stopUICallback(self.scb)
        self.ui.stopUICallback(self.ccb)


    def CloseHit(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.stop()
            if not self.deferred.called:
                self.deferred.callback(0)
        except:
            import traceback
            traceback.print_exc()


    def FillList(self):
        """
        You need to add a docstring here ! 
        """
        # print 'FilllistStart'
        d = self.plugin.callRemote("getObjects", (0, 0))
        d.addCallback(self.FillList_GotList)
        d.addErrback(self.ui.client.Error)
        # print "filllistend"


    def FillList_GotList(self, r):
        """
        You need to add a docstring here ! 
        """
        # print "gotList"
        lb = self.ui.getComponent("WorldEditor/Select/List")
        #print self.items
        lb.resetList()
        self.items = []
        #for ii in self.items:
        #try:
            #if len(self.items):
                #lb.removeItem(self.items[1])
        #except:
            #print "Listbox issue!"
        #self.items=[]
        #lb.removeRow(1)
        if len(r.keys()):
            k = r.keys()[0]
            lb.text = "%s: %s" % (str(k), r[k])
        # print "Created keys"
        for k, v in r.items():
            self.items.append(self.ui.addItemToListBox(lb, "%s: %s" % (str(k), v)))
        # print "Donefilllistgotlist"


    def SelectHit(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            lb = self.ui.getComponent("WorldEditor/Select/List")
            if lb.selectedCount == 0:
                return
            tt = lb.getFirstSelectedItem().text.c_str()
            s = tt.split(":")
            val = parseInstanceId(s[0])
            self.stop()
            self.ige.DeselectAll()
            self.ige.SelectItem(val)
            self.deferred.callback(val)
        except:
            # print "SELECT ERROR"
            import traceback
            print traceback.print_exc()



class MousePickObject(IGEClientPlugin):
    """
    You need to add a docstring here ! 
    """
    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return "MousePickObject"




    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return "Select"


    def createButton(self, pos, sz, par):
        """
        You need to add a docstring here ! 
        """
        c = self.ui.createComponent("WindowsLook/SystemButton", 
            "Plugin_%s" % self.getName(), pos, sz, [0.01, 0.01], 
            [1.0, 1.0], "")
        self.ui.setButtonImages(c, "ArrowButtonN.png", "ArrowButtonH.png", "ArrowButtonA.png")
        par.addChildWindow(c)
        return c


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.requestMouseCallback(self.MouseCB)


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.stopMouseCallback(self.MouseCB)


    def activated(self, args):
        """
        You need to add a docstring here ! 
        """
        try:
            self.start()
        except:
            # print "ERRRROR"
            import traceback
            traceback.print_stack()


    def MouseCB(self, btn, pos, rel, mods):
        """
        You need to add a docstring here ! 
        """
        try:
            if btn[0] != 0:
                #self.PickObjectVisual(pos,mods)
                self.PickObjectPhysical(pos)
            if btn[2] != 0:
                #self.PickObjectPhysical(pos)
                self.stop()
        except:
            # print "ERRRROR"
            import traceback
            print traceback.print_exc()


    def PickObjectVisual(self, pos, mods):
        """
        Translated from:
            http://www.ogre3d.org/wiki/index.php/ThreeDeeObjectPicking
            -- This picks an object based on the mouse position, but
            it also selects from the visual representation.
            it would be worthwhile to make an alternate version that
            selects by the physics representation.
        """
        ss = self.ui.renderer.getScreenDimensions()
        cam = self.ui.renderer.camera
        tx = pos[0] / float(ss[0])
        ty = pos[1] / float(ss[1])
        #tx=pos[0]
        #ty=pos[1]
        # print "Click yer bic at", tx, ty, ss
        # print "from", pos
        #ray = cam.getCameraToViewportRay(tx - 0.5, 0.5 - ty)
        ray = cam.getCameraToViewportRay(tx, ty)
        mpRayQuery = self.ui.renderer.sceneManager.createRayQuery(ray)
        mpRayQuery.setSortByDistance(1)
        #mpRayQuery.maxResults=1
        res = mpRayQuery.execute()
        #print dir(res), res[0]
        #it = res.begin()
        m = 0
        # print "origin=", ray.origin, ray.getPoint(20000)
        # create a line!
        if not hasattr(self, "testnode"):
            self.testnode = OgreNode(self.ui.renderer)
            self.testnode.initialize("Testies%f" % time.time())
            self.testobj = OgreObject(self.ui.renderer)
            clear = False
        else:
            clear = True



        class StupidMaterial:
            """
            You need to add a docstring here ! 
            """
            def getFilename(self):
                return "white"


        self.testobj.createManual("booger%f" % time.time(), verts = [ray.origin, ray.getPoint(2000)], 
            material = StupidMaterial(), renderoperation = ogre.RenderOperation.OT_LINE_LIST, recreate = clear)
        if not clear:
            self.testnode.addObject(self.testobj)
        # print "RES = ", len(res)
        clo = 999999999
        for x in range(len(res)):
            # print res[x].distance, res[x].movable
            if res[x].distance < clo:
                clo = res[x].distance
                if hasattr(res[x], "movable"):
                    m = res[x].movable
                else:
                    m = res[x]
        mpRayQuery.clearResults()
        # print "M==", m
        #print dir(m)
        if m != 0 and hasattr(m, "name"):
            # print m.name
            sid = parseInstanceId(m.name)
            if isinstance(sid, tuple):
                self.ige.SelectItem(sid, 1 - mods[2])
        return m


    def PickObjectPhysical(self, pos):
        """
        Translated from:
            http://www.ogre3d.org/wiki/index.php/ThreeDeeObjectPicking
            -- This picks an object based on the mouse position, but
            it also selects from the physical representation.
        """
        ss = self.ui.renderer.getScreenDimensions()
        cam = self.ui.renderer.camera
        tx = pos[0] / float(ss[0])#(1.0 / ss[0]) * pos[0]
        ty = pos[1] / float(ss[1])#(1.0 / ss[1]) * pos[1]
        # print "Click yer bic at", tx, ty
        # print "from", pos
        #ray = cam.getCameraToViewportRay(tx - 0.5, 0.5 - ty)
        ray = cam.getCameraToViewportRay(tx , ty)
        pcid = self.ui.client.getInterface("Player Client").pcid
        area = self.ui.client.getInterface("Simulation Client").inview[pcid].areas.values()[0]
        spaces = [area.dspace, area.space]
        # print ray.origin, ray.getPoint(20000)
        # create a line!
        if not hasattr(self, "testnode"):
            self.testnode = OgreNode(self.ui.renderer)
            self.testnode.initialize("Testies%f" % time.time())
            self.testobj = OgreObject(self.ui.renderer)
            clear = False
        else:
            clear = True



        class StupidMaterial:
            """
            You need to add a docstring here ! 
            """
            def getFilename(self):
                return "white"


        self.testobj.createManual("booger%f" % time.time(), verts = [ray.origin, ray.getPoint(2000)], 
            material = StupidMaterial(), renderoperation = ogre.RenderOperation.OT_LINE_LIST, recreate = clear)
        if not clear:
            self.testnode.addObject(self.testobj)
        for space in spaces:
            r = castRay(space, ray.origin, ray.getPoint(20000))
            #print r
            if r.mingeom != 0:
                m = r.mingeom
                # print "M==", m, m.oid
                if m.oid != 0:
                    # print "boom, you got", m.oid
                    self.ige.SelectItem(m.oid, 1)
                return m
        return 0
