# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.


from twisted.internet import defer
from mv3d.client.ui.cegui import UserInterface


created = 0

class IGEClientPlugin(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        pass


    def initialize(self, ui, ige, pi):
        """
        You need to add a docstring here ! 
        """
        self.ui = ui
        self.ige = ige
        self.plugin = pi


    def finalize(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def start(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return ""


    def GetSection(self):
        """
        You need to add a docstring here ! 
        """
        return ""


    def createButton(self, pos, sz, par):
        """
        Create the button that we'll use to activate
            this component. Should return the gui element, but
            can also return 0 (for none), or a deferred
        """
        return 0


    def activate(self):
        """
        Called whenever this plugin is activated. 
        """
        pass



class IGEClientBase(UserInterface):
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        self.sections = {}
        self.uicbs = []
        self.started = 0
        self.params = {}
        self.selected = []
        self.visible = 0




    def initialize(self, ui, ige):
        """
        You need to add a docstring here ! 
        """
        global created
        self.ui = ui
        self.ige = ige
        if not created:
            created = 1
            self.basewindow = ui.createComponent("WindowsLook/FrameWindow", 
                "IGEBase", [0.05, 0.05], [0.2, 0.3], [0.01, 0.01], [1.0, 1.0], 'IGE Toolbar')
            #self.basewindow.alpha=0.8
            d = self.GetPlugins()
            d.addCallback(self.initialize_GotPlugins)


    def initialize_GotPlugins(self, r):
        """
        now we must go through all the plugins
            and create the components for them where
            needed """
        bperrow = 5 # buttons per row
        bwidth = 1.0 / bperrow
        nsect = len(self.sections)
        trows = nsect
        for s in self.sections.values():
            trows += len(s) / bperrow + 1
        bheight = 0
        if trows > 0:
            bheight = 0.85 / trows
        ypos = 0.15
        for sn, sv in self.sections.items():
            # create the section header
            c = self.ui.createComponent("WindowsLook/StaticText", 
                "SectionText_%s" % sn, [0.0, ypos], [1.0, bheight], [0.01, 0.01], [1.0, 1.0], sn)
            self.basewindow.addChildWindow(c)
            ypos += bheight
            # now create the buttons for the plugins
            xpos = 0
            for pl in sv:
                c = pl.createButton([xpos, ypos], [bwidth, bheight], self.basewindow)
                if self.started:
                    # print "Registering callback"
                    self.uicbs.append(self.ui.requestUICallback("Plugin_%s" % pl.getName(), "EventClicked", pl, "activated"))
                xpos += bwidth
                if xpos >= 1.0:
                    xpos = 0
                    ypos += bheight
            ypos += bheight


    def finalize(self):
        """
        You need to add a docstring here ! 
        """
        pass


    def iterate(self, time):
        """
        You need to add a docstring here ! 
        """
        pass


    def start(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.displayWindow(self.basewindow)
        self.started = 1
        self.visible = 1
        self.ccb = self.ui.requestUICallback("IGEBase", "EventCloseClicked", self, "ToggleWindow")
        # register callbacks for all the plugins
        #for sv in self.sections.values():
            #print "section",len(sv)
            #for pl in sv:
                #self.uicbs.append(self.ui.requestUICallback("Plugin_%s"%pl.getName(),"EventClicked",pl,"Selected"))
                #print "Registered callback for","Plugin_%s"%pl.getName()


    def ToggleWindow(self, dd=0):
        """
        You need to add a docstring here ! 
        """
        try:
            if self.visible:
                self.ui.hideWindow(self.basewindow)
                self.visible = 0
            else:
                self.ui.displayWindow(self.basewindow)
                self.visible = 1
        except:
            import traceback
            traceback.print_exc()


    def GetPlugins(self):
        """
        Get the plugins and sections from the server... 
        """
        # first we will get the sections
        d = self.ige.callRemote("GetPlugins")
        d.addCallback(self.GetPlugins_GotPlugins)
        return d


    def GetPlugins_GotPlugins(self, p):
        """
        Now we have to go through all these remote views and
            get the UIs associated with them.
        """
        dd = []
        for pl in p:
            d = pl.callRemote("GetUI")
            d.addCallback(self.GetPlugins_GotUI, pl)
            dd.append(d)
        dl = defer.DeferredList(dd)
        #dl.addCallback(
        return dl


    def GetPlugins_GotUI(self, uicg, p):
        """
        You need to add a docstring here ! 
        """
        d = uicg.construct()
        if isinstance(d, defer.Deferred):
            d.addCallback(self.GetPlugins_ConstructedUI, p)
            return d
        return self.GetPlugins_ConstructedUI(d, p)


    def GetPlugins_ConstructedUI(self, ui, p):
        """
        You need to add a docstring here ! 
        """
        if isinstance(ui, int):
            return 0
        s = ui.GetSection()
        if not self.sections.has_key(s):
            self.sections[s] = []
        ui.initialize(self.ui, self, p)
        self.sections[s].append(ui)
        return 1 


    def stop(self):
        """
        You need to add a docstring here ! 
        """
        self.ui.hideWindow(self.basewindow)
        self.ui.stopUICallback(self.ccb)
        for cb in self.uicbs:
            self.ui.stopUICallback(cb)
        self.started = 0


    def SetParam(self, p, v):
        """
        You need to add a docstring here ! 
        """
        self.params[p] = v


    def GetParam(self, p):
        """
        You need to add a docstring here ! 
        """
        return self.params.get(p)


    def RemParam(self, p):
        """
        You need to add a docstring here ! 
        """
        if self.params.has_key(p):
            del self.params[p]
            return 1
        return 0


    def SelectItem(self, ob, cl=0):
        """
        You need to add a docstring here ! 
        """
        if cl:
            self.DeselectAll()
        self.selected.append(ob)
        ss = self.ui.client.getInterface("Simulation Client")
        o = ss.getItem(ob)
        if o:
            if hasattr(o, "Select"):
                o.select()


    def DeselectItem(self, ob):
        """
        You need to add a docstring here ! 
        """
        if ob in self.selected:
            self.selected.remove(ob)
            ss = self.ui.client.getInterface("Simulation Client")
            o = ss.getItem(ob)
            if o:
                if hasattr(o, "Deselect"):
                    o.deselect()
            return 1
        return 0


    def DeselectAll(self):
        """
        You need to add a docstring here ! 
        """
        ss = self.ui.client.getInterface("Simulation Client")
        for ob in self.selected:
            o = ss.getItem(ob)
            if o:
                if hasattr(o, "Deselect"):
                    o.deselect()
        self.selected = []


    def GetSelection(self):
        """
        You need to add a docstring here ! 
        """
        return self.selected


    def getAssetSelector(self):
        """
        You need to add a docstring here ! 
        """
        d = self.ige.callRemote("getAssetSelector")
        d.addCallback(self.getAssetSelector_GotInterface)
        return d


    def getAssetSelector_GotInterface(self, i):
        """
        You need to add a docstring here ! 
        """
        if isinstance(i, int):
            return 0
        d = i.callRemote("GetUI")
        d.addCallback(self.getAssetSelector_GotCG, i)
        return d


    def getAssetSelector_GotCG(self, cg, i):
        """
        You need to add a docstring here ! 
        """
        d = cg.construct()
        if isinstance(d, defer.Deferred):
            d.addCallback(self.getAssetSelector_Constructed, i)
            return d
        return self.getAssetSelector_Constructed(d, i)


    def getAssetSelector_Constructed(self, ui, i):
        """
        You need to add a docstring here ! 
        """
        ui.initialize(self.ui, i)
        return ui
