# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
A View Of an Area 
"""

import ode

from mv3d.net.security import Securable
from mv3d.net.pb import Cacheable
from mv3d.util.classgen import ClassGenerator
from mv3d.client.ui.ogre3d import OgreNode
from mv3d.util.conductor import IPlayerClient


class AreaView(Securable, Cacheable):
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        self.realm = 0
        self.iid = -1


    def getID(self):
        """
        You need to add a docstring here ! 
        """
        return self.iid


    def setID(self, i):
        """
        You need to add a docstring here ! 
        """
        self.iid = i
        self.updateClients("setID", i)


    def observe_setID(self, i):
        """
        You need to add a docstring here ! 
        """
        self.iid = i


    def getRealm(self):
        """
        You need to add a docstring here ! 
        """
        return self.realm


    def setRealm(self, r):
        """
        You need to add a docstring here ! 
        """
        self.realm = r
        self.updateClients("setRealm", r)


    def observe_setRealm(self, r):
        """
        You need to add a docstring here ! 
        """
        self.realm = r


    def iterate(self, i):
        """
        You need to add a docstring here ! 
        """
        pass


    def getStateToCacheAndObserveFor(self, perspective, observer):
        """
        You need to add a docstring here ! 
        """
        return Cacheable.getStateToCacheAndObserveFor(self, perspective, observer)


    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        Cacheable.setCopyableState(self, state)


    def getClassGenerator(self):
        """
        You need to add a docstring here ! 
        """
        return ClassGenerator(classname = "AreaView", 
            modulename = "mv3d.client.view.area", 
            sourceclass = "mv3d.server.model.area.AreaView")



class odeAreaViewClient(AreaView):
    """
    You need to add a docstring here ! 
    """
    world = None
    realm = None
    node = None
    step = 0.01

    def __init__(self):
        AreaView.__init__(self)
        #print "init areaview"
        self.space = ode.HashSpace()
        self.dspace = ode.HashSpace()
        self.sspace = ode.HashSpace()
        # print "AREAREAREAREA", self.space, self.dspace
        self.contactgroup = ode.JointGroup()
        self.addExclude("space")
        self.addExclude("world")
        self.addExclude("contactgroup")


    def remove(self):
        """
        You need to add a docstring here ! 
        """
        # print "Removing Area!", self.getID()
        # AreaView.remove(self)


    def getEnabledSpace(self, pos=None):
        """
        You need to add a docstring here ! 
        """
        return self.space



    def getDisabledSpace(self, pos=None):
        """
        You need to add a docstring here ! 
        """
        return self.dspace


    def getSpecialSpace(self, pos=None):
        """
        You need to add a docstring here ! 
        """
        return self.sspace


    def setup(self):
        """
        You need to add a docstring here ! 
        """
        assert self.realm is not None
        self.world = self.realm.world
        assert self.node is None
        self.realm.addPhysicsArea(self)
        self.node = OgreNode(self.parent.parent.getLocalService(
            IPlayerClient).getRenderer())
        self.node.initialize(str(self.getID()))
        # print "Setup nodey"


    def getNode(self):
        """
        You need to add a docstring here ! 
        """
        if self.node is None:
            self.setup()
        return self.node


    def setTranslation(self, p):
        """
        You need to add a docstring here ! 
        """
        if self.node is None:
            self.setup()
        self.node.setPosition(p)


    def iterate(self, t):
        """
        You need to add a docstring here ! 
        """
        if self.world is None:
            self.setup()


    def collide(self, cm):
        """
        You need to add a docstring here ! 
        """
        # print len(self.space), len(self.dspace), len(self.sspace)
        cm.collideInternal(self.space)
        cm.collide(self.space, self.dspace)
        cm.collide(self.space, self.sspace)


    getStateToCacheAndObserveFor = Cacheable.getStateToCacheAndObserveFor
    setCopyableState = Cacheable.setCopyableState

