# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
from ogre.renderer import OGRE as ogre

from twisted.spread import pb

from mv3d.net.pb import Cacheable
from mv3d.net.security import Securable
from mv3d.reporter.event import FilterCondition, Filter
from mv3d.reporter.event import EventSubscription
from mv3d.util import math3d as VectorMath
from mv3d.util.conductor import ISimulationClient, IPlayerClient


class PlayerViewClient(Securable, Cacheable):
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        self.pcid = -1
        self.pc = 0
        self.simclient = 0
        self.pcarea = 0
        self.cameraoffs = (0,  - 2, 20)
        self.camerarot = (1, 0, 0, 0)


    def observe_setAreaOffset(self, aid, t, r):
        """
        You need to add a docstring here ! 
        """
        # print self.parent.frame, "observe_setAreaOffset", aid, t, r
        self.simclient.areatranslations[aid] = t
        self.simclient.arearotations[aid] = r
        if self.simclient.areas.has_key(aid):
            self.simclient.areas[aid].setTranslation(t)


    def observe_addToView(self, o):
        """
        You need to add a docstring here ! 
        """
        # print "o_addToView",o.getID()#, dir(o)
        # print o.body.vobs[0]
        o.setParent(self.simclient)
        if self.simclient.inview.has_key(o.getID()):
            # see if it is active...
            oo = self.simclient.inview[o.getID()]
            if oo.hasLostMaster():
                self.simclient.inview[o.getID()].destroy()
                del self.simclient.inview[o.getID()]
                del oo
            else:
                # print "We've already got one!!!!!!!!", self.simclient.inview[o.getID()], o, o.getID()
                return
        self.simclient.inview[o.getID()] = o
        #print "are these the same?", o, self.simclient.inview[o.getID()]
        #print o.areas, self.areas
        for a in o.areas.values():
            if not a.getID() in self.simclient.areas.keys():
                self.simclient.areas[a.getID()] = a
                a.setup()
                if self.simclient.areatranslations.has_key(a.getID()):
                    a.setTranslation(self.simclient.areatranslations[a.getID()])
            elif self.simclient.areas[a.getID()].hasLostMaster():
                a.node = self.simclient.areas[a.getID()].getNode()
                self.simclient.areas[a.getID()].realm.remPhysicsArea(self.simclient.areas[a.getID()])
                self.simclient.areas[a.getID()] = a
            if not a.realm.getID() in self.simclient.realms.keys():
                self.simclient.realms[a.realm.getID()] = a.realm
            elif self.simclient.realms[a.realm.getID()].hasLostMaster():
                a.areas = self.simclient.realms[a.realm.getID()].areas
                a.world = self.simclient.realms[a.realm.getID()].world
                self.simclient.realms[a.realm.getID()] = a
        o.create()
        if o.getID() == self.pcid:
            self.pc = o
        if o.isEnabled():
            self.simclient.enabled.append(o)
        else:
            self.simclient.disabled.append(o)
            #print "Found it"
        #print "areas",len(self.areas)


    def observe_remFromView(self, o):
        """
        You need to add a docstring here ! 
        """
        # print "o_RemFromView",o#, len(self.simclient.areas)
        if not self.simclient.inview.has_key(o):
            # print "We don't got none of those!"
            return
        oo = self.simclient.inview[o]
        if oo in self.simclient.enabled:
            self.simclient.enabled.remove(oo)
        if oo in self.simclient.disabled:
            self.simclient.disabled.remove(oo)
        self.simclient.inview[o].destroy()
        del self.simclient.inview[o]
        del oo
        #print len(self.simclient.areas)


    def updateCamera(self):
        """
        You need to add a docstring here ! 
        """
        if self.pc == 0:
            return
        #p=VectorMath.addVectors(self.pc.getPosition(),self.pc.getViewPointOffset())
        #p=self.pc.getPosition()
        #print "pos",p
        #r=self.pc.getRotation()
        p, r = self.pc.getViewPoint()
        r = VectorMath.multiplyQuaternions(r, self.camerarot)
        r = VectorMath.normalizeQuaternion(r)
        d = self.cameraoffs
        dr = VectorMath.rotateVector(d, r)
        if self.camera:
            vv = VectorMath.addVectors(p, dr)
            # if abs(self.camera.getPosition()[2] - vv[2]) > 300:
                # print self.parent.frame, "Changing camera"
            self.camera.setPosition(ogre.Vector3(vv[0], vv[1], vv[2]))
            self.camera.setOrientation(ogre.Quaternion(r[0], r[1], r[2], r[3]))


    def receiveEvent(self, e):
        """
        You need to add a docstring here ! 
        """
        try:
            mm = self.parent.parent.getLocalService(
                IPlayerClient).getUI().getComponent("Message")
            st = mm.text.c_str()
            st += str(e)
            mm.text = st
            mm.caratIndex = len(st)
        except RuntimeError:
            print e


    observe_receiveEvent = receiveEvent


    def iterate(self, time):
        """
        You need to add a docstring here ! 
        """
        #self.updateCamera()
        pass


    def runPhysics(self, time):
        """
        You need to add a docstring here ! 
        """
        for r in self.simclient.realms.values():
            r.iterate(time)
        #if self.inview.has_key(self.pcid):
            #self.inview[self.pcid].iterate(time)


    def iteratePC(self, time):
        """
        You need to add a docstring here ! 
        """
        if self.simclient.inview.has_key(self.pcid):
            self.simclient.inview[self.pcid].iterate(time)
            self.updateCamera()
            if self.pcarea != 0 and len(self.simclient.inview[self.pcid].areas):
                if self.pcarea != self.simclient.inview[self.pcid].areas.values()[0]:
                    a = self.simclient.inview[self.pcid].areas.values()[0]
                    t = self.simclient.areatranslations.get(a.getID(), (0, 0, 0))
                    # print self.parent.frame, "Swapped areas!", t
                    for k, v in self.simclient.areatranslations.items():
                        self.observe_setAreaOffset(k, VectorMath.subtractVectors(v, t), (1, 0, 0, 0))
                    self.pc.setPosition(VectorMath.subtractVectors(self.pc.getPosition(), t))
                    self.updateCamera()
            if len(self.simclient.inview[self.pcid].areas):
                self.pcarea = self.simclient.inview[self.pcid].areas.values()[0]


    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        Cacheable.setCopyableState(self, state)
        i = self.parent.parent.getLocalService(
            IPlayerClient).getRenderer()
        self.camera = i.camera
        self.updateCamera()
        f = Filter()
        f.addRule(FilterCondition(item = "date",
            test = ">", parameters = ["yesterday"]))
        es = EventSubscription(self.receiveEvent)
        es.addFilter(f)
        self.parent.parent.getEventService().subscribe(es)
        #f=Filter()
        #f.addRule(FilterCondition(item="category",test="==",parameters=["chat"]))
        self.simclient = self.parent.parent.getLocalService(ISimulationClient)
        # print self.inview, self.areas
        for o in self.inview.values():
            self.observe_addToView(o)
        # self.simclient.inview.update(self.inview)
        self.simclient.areas.update(self.areas)
        self.simclient.realms.update(self.realms)
        self.inview = {}
        self.areas = {}
        self.realms = {}
        self.simclient.pcid = self.pcid
        if self.simclient.inview.has_key(self.pcid):
            self.pc = self.simclient.inview[self.pcid]
        for o in self.simclient.inview.values():
            self.simclient.areas.update(o.areas)
            self.simclient.realms.update(o.realms)
            if o.isEnabled():
                self.simclient.enabled.append(o)
            else:
                self.simclient.disabled.append(o)


    def observe_sendUpdates(self, updates):
        """
        You need to add a docstring here ! 
        """
        x = 0
        #print "Got updates",len(updates)/15
        while x < len(updates):
            i = (updates[x], updates[x + 1])
            if not self.simclient.inview.has_key(i):
                return
            x += 2
            o = self.simclient.inview[i]
            p = (updates[x], updates[x + 1], updates[x + 2])
            x += 3
            r = (updates[x], updates[x + 1], updates[x + 2], updates[x + 3])
            x += 4
            lv = (updates[x], updates[x + 1], updates[x + 2])
            x += 3
            av = (updates[x], updates[x + 1], updates[x + 2])
            x += 3
            #print "Update",i#,p,r,lv,av
            o.observe_updatePhysics(p, r, lv, av)
            
            
pb.setUnjellyableForClass("mv3d.server.player.PlayerView", PlayerViewClient)
