# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
A view of a realm 
"""

import ode

from mv3d.net.pb import Cacheable
from mv3d.net.security import Securable
from mv3d.util.classgen import ClassGenerator
from mv3d.phys.collider import CollisionMaker
from mv3d.util.conductor import IPlayerClient
from mv3d.client.ui.ogre3d import CaelumSky


class RealmView(Securable, Cacheable):
    """
    You need to add a docstring here ! 
    """
    id = -1
    def getID(self):
        """
        You need to add a docstring here ! 
        """
        return self.iid


    def setID(self, i):
        """
        You need to add a docstring here ! 
        """
        self.iid = i
        self.updateClients("setID", i)


    def observe_setID(self, i):
        """
        You need to add a docstring here ! 
        """
        self.iid = i


    def iterate(self, i):
        """
        You need to add a docstring here ! 
        """
        pass


    def getStateToCacheAndObserveFor(self, perspective, observer):
        """
        You need to add a docstring here ! 
        """
        return Cacheable.getStateToCacheAndObserveFor(self, perspective, observer)



    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        Cacheable.setCopyableState(self, state)


    def getClassGenerator(self):
        """
        You need to add a docstring here ! 
        """
        return ClassGenerator(classname = "RealmView", 
            modulename = "mv3d.client.view.RealmView", 
            sourceclass = "mv3d.server.model.realm.RealmView")



class Ogre3DBasicSkyView(Securable, Cacheable):
    """
    You need to add a docstring here ! 
    """
    def setup(self):
        """
        You need to add a docstring here ! 
        """
        r = self.parent.parent.getLocalService(IPlayerClient).getRenderer()
        self.caelum = CaelumSky(r)
        self.caelum.create()
 

    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        Cacheable.setCopyableState(self, state)



class odeRealmViewClient(RealmView):
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        self.physicsproperties = {}
        #print "init Realm view"
        self.world = ode.World()
        self.cm = CollisionMaker(self.world)
        #print "Done"
        self.physicsproperties["maxstep"] = 0.05
        self.physicsproperties["maxiters"] = 1
        self.areas = []
        self.mips = 10
        self.sky = 0


    def remove(self):
        """
        You need to add a docstring here ! 
        """
        # print "Removing realm!", self.getID()
        # import traceback
        # print traceback.print_stack()
        # RealmView.__del__(self)


    def getPhysicsProperty(self, k, dv=None):
        """
        You need to add a docstring here ! 
        """
        return self.physicsproperties.get(k, dv)


    def setup(self):
        """
        You need to add a docstring here ! 
        """
        #print "setup realm view"
        if self.sky != 0:
            self.sky.setup()
        if self.getPhysicsProperty("gravity"):
            self.world.setGravity(self.getPhysicsProperty("gravity"))
        if self.getPhysicsProperty("ERP"):
            self.world.setERP(self.getPhysicsProperty("ERP"))
        if self.getPhysicsProperty("CFM"):
            self.world.setCFM(self.getPhysicsProperty("CFM"))
        if self.getPhysicsProperty("autodisable"):
            self.world.setAutoDisableFlag( self.getPhysicsProperty("autodisable"))
            self.world.setAutoDisableLinearThreshold(1)
            self.world.setAutoDisableAngularThreshold(1)
            self.world.setAutoDisableSteps(5)
        else:
            self.world.setAutoDisableFlag(False)
            self.world.setAutoDisableLinearThreshold(1)
            self.world.setAutoDisableAngularThreshold(1)
            self.world.setAutoDisableSteps(5)
        #self.world.setQuickStepNumIterations(10)
        #self.world.setContactSurfaceLayer(0.001)


    def addPhysicsArea(self, a):
        """
        You need to add a docstring here ! 
        """
        self.areas.append(a)
        #print "Added phys area"


    def remPhysicsArea(self, a):
        """
        You need to add a docstring here ! 
        """
        if not a in self.areas:
            return 0
        self.areas.remove(a)
        return 1


    def iterate(self, i):
        """
        You need to add a docstring here ! 
        """
        stime = self.getPhysicsProperty("maxstep", 0.05)
        siters = self.getPhysicsProperty("maxiters", 1)
        for x in range(siters):
            self.world.quickStep(stime)
            self.cm.clearCollisions()
            for a in self.areas:
                a.collide(self.cm)



    def getStateToCacheAndObserveFor(self, perspective, observer):
        """
        You need to add a docstring here ! 
        """
        return Cacheable.getStateToCacheAndObserveFor(self, perspective, 
            observer)


    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        Cacheable.setCopyableState(self, state)
        self.setup()

