# Copyright (C) 2006-2008 Mortal Coil Games
# See LICENSE for details.
"""
"""

from twisted.internet import defer

from mv3d.util.datastore.store import attributes, autoStore, text, classHash
from mv3d.resource.asset import CodeAsset, SoundAsset
from mv3d.util.classgen import ClassGenerator
from mv3d.net.pb import Cacheable, withClientUpdate


def newLocalClassGeneratorAsset(assetgroup, modulename, classname, name="", 
    depends=[]):
    """
    You need to add a docstring here ! 
    """
    tm = assetgroup.newAsset(ClassGenerator(classname = "LocalClassGeneratorAsset", 
        modulename = "mv3d.resource.local"))
    def finishUp(tm, m, c, n, d):
        """
        You need to add a docstring here ! 
        """
        tm.setModule(m)
        tm.setClass(c)
        if name != "":
            tm.setName(name)
        else:
            tm.setName(c)
        for d in depends:
            if isinstance(d, tuple):
                tm.addDependency(d)
            else:
                tm.addDependency(d.getID())
        for d in depends:
            if isinstance(d, tuple):
                tm.addDependency(d)
            else:
                tm.addDependency(d.getID())
        return tm
    if isinstance(tm, defer.Deferred):
        tm.addCallback(finishUp, modulename, classname, name, depends)
        return tm
    return finishUp(tm, modulename, classname, name, depends)



class LocalClassGeneratorAsset(CodeAsset):
    """
    You need to add a docstring here ! 
    """
    datastoreAttributes = attributes(CodeAsset, modulename=text,
        classname=text)
    datastoreHash = ("aid", classHash)
    datastoreVersion = 1


    def __init__(self, modulename=None, classname=None, server=None, datastore=None):
        CodeAsset.__init__(self)
        self.modulename = modulename
        self.classname = classname
        self.datastore = datastore
        self.server = server


    def getModule(self):
        """
        You need to add a docstring here ! 
        """
        return self.modulename


    @autoStore
    @withClientUpdate
    def setModule(self, f):
        """
        You need to add a docstring here ! 
        """
        self.modulename = f


    def getClass(self):
        """
        You need to add a docstring here ! 
        """
        return self.classname


    @autoStore
    @withClientUpdate
    def setClass(self, f):
        """
        You need to add a docstring here ! 
        """
        self.classname = f


    observe_setModule = setModule
    observe_setClass = setClass


    def haveAsset(self):
        """
        You need to add a docstring here ! 
        """
        return 1


    def getCG(self):
        """
        You need to add a docstring here ! 
        """
        return ClassGenerator(modulename=self.modulename,
            classname=self.classname, assetid=self.getID())


    def getStateToCacheAndObserveFor(self, perspective, observer):
        """
        You need to add a docstring here ! 
        """
        return Cacheable.getStateToCacheAndObserveFor(self, perspective, observer)


    def setCopyableState(self, state):
        """
        You need to add a docstring here ! 
        """
        return Cacheable.setCopyableState(self, state)



class LocalSoundAsset(SoundAsset):
    """
    A sound that is stored on this computer
    """
    datastoreAttributes = attributes(SoundAsset, filename=text)
    datastoreHash = ("aid", classHash)
    datastoreVersion = 1


    def __init__(self, filename=None, datastore=None):
        SoundAsset.__init__(self)
        self.filename = filename
        self.datastore = datastore


    def getFilename(self):
        return self.filename


    @autoStore
    @withClientUpdate
    def setFilename(self, f):
        self.filename=f


    observe_setFilename = setFilename
    getStateToCacheAndObserveFor = Cacheable.getStateToCacheAndObserveFor
    setCopyableState = Cacheable.setCopyableState

