# Copyright (C) 2007-2008 Mortal Coil Games
# See LICENSE for details.
"""
Class for a Player client interface
    Handles controlling the remote PC, taking player input
    and converting it to calls to the PC.
    Handles connecting to a PC as well.
"""


KeyMap = {}



def setupKeys():
    """
    You need to add a docstring here ! 
    """
    global KeyMap
    from ogre.io import OIS
    for l in "abcdefghijklmnopqrstuvwxyz1234567890":
        lc = l
        uc = l.upper()
        b = getattr(OIS, "KC_%s" % uc)
        KeyMap[lc] = b
    sk = ["up", "down", "left", "right", "tab", "f1", "f2", "f3", "f4", "f5", "f6", "f7", "f8", "f9", "f10", "f11", "f12", 
        "escape", "minus", "equals", "back", "tab", "lbracket", "rbracket", "return", "lcontrol", "lshift", "rcontrol", 
        "rshift", "semicolon", "apostrophe", "grave", "backslash", "comma", "period", "slash", "multiply", "lmenu", 
        "rmenu", "space", "capital", "numlock", "scroll", "numpad0", "numpad1", "numpad2", "numpad3", "numpad4", 
        "numpad5", "numpad6", "numpad7", "numpad8", "numpad9", "add", "decimal", "sysrq", "pause", "home", "pgup", 
        "pgdown", "delete", "insert", "lwin", "rwin", "end"]
    for s in sk:
        b = getattr(OIS, "KC_%s" % s.upper())
        KeyMap[s] = b


setupKeys()


class Binding:
    """
    You need to add a docstring here ! 
    """
    def __init__(self, ui):
        self.Types = ["Key", "Mouse", "UI Event"]
        self.ui = ui
        self.type = ""
        self.which = ""
        self.extra = ""
        self.modkeys = []
        self.callback = 0
        self.active = 0


    def setType(self, t):
        """
        You need to add a docstring here ! 
        """
        self.type = t
        if self.active:
            self.deactivate()
            self.activate()


    def getType(self):
        """
        You need to add a docstring here ! 
        """
        return self.type


    def setWhich(self, w):
        """
        You need to add a docstring here ! 
        """
        self.which = w
        if self.active:
            self.deactivate()
            self.activate()


    def getWhich(self):
        """
        You need to add a docstring here ! 
        """
        return self.which


    def setKey(self, k):
        """
        You need to add a docstring here ! 
        """
        self.which = KeyMap[k]
        self.type = "Key"
        if self.active:
            self.deactivate()
            self.activate()


    def setExtra(self, e):
        """
        You need to add a docstring here ! 
        """
        self.extra = e


    def getExtra(self):
        """
        You need to add a docstring here ! 
        """
        return self.extra


    def setModKeys(self, m):
        """
        You need to add a docstring here ! 
        """
        self.modkeys = m


    def getModKeys(self):
        """
        You need to add a docstring here ! 
        """
        return self.modkeys


    def setCallback(self, c):
        """
        You need to add a docstring here ! 
        """
        self.callback = c


    def getCallback(self):
        """
        You need to add a docstring here ! 
        """
        return self.callback


    def activate(self):
        """
        You need to add a docstring here ! 
        """
        self.active = 1
        if self.type == "Key":
            return self.ui.requestKeyCallback(self.which, self.callback)
        if self.type == "Mouse":
            return self.ui.requestMouseCallback(self.callback)
        if self.type == "UI Event":
            self.extra = self.ui.requestUICallback(self.which[0], self.which[1], self.callback)
            return 1
        raise Exception("Unknown binding type.. %s" % self.type)


    def deactivate(self):
        """
        You need to add a docstring here ! 
        """
        self.active = 0
        if self.type == "Key":
            return self.ui.stopKeyCallback(self.which)
        if self.type == "Mouse":
            return self.ui.stopMouseCallback(self.callback)
        if self.type == "UI Event":
            return self.ui.stopUICallback(self.extra)
        raise Exception("Unknown binding type.. %s" % self.type)


    def callback(self, *args):
        """
        You need to add a docstring here ! 
        """
        # should check modifier keys....
        if self.type == "Key":
            self.callback( * args)
            return
        if self.type == "Mouse":
            if self.which < 3:
                if args[0][self.which]:
                    self.callback( * args)
            return
        if self.type == "UI Event":
            self.callback( * args)
            return
        raise Exception("Unknown binding type.. %s" % self.type)



class Action:
    """
    You need to add a docstring here ! 
    """
    def __init__(self):
        self.Types = ["PC Action", "Local Function", "Remote Function", "Create UI"]
        self.name = ""
        self.desc = ""
        self.type = ""
        self.action = ""
        self.args = []
        self.params = {}
        self.bindings = []
        self.server = 0


    def setServer(self, s):
        """
        You need to add a docstring here ! 
        """
        self.server = s


    def setName(self, n):
        """
        You need to add a docstring here ! 
        """
        self.name = n


    def getName(self):
        """
        You need to add a docstring here ! 
        """
        return self.name


    def setDescription(self, d):
        """
        You need to add a docstring here ! 
        """
        self.desc = d


    def getDescription(self):
        """
        You need to add a docstring here ! 
        """
        return self.desc


    def setType(self, t):
        """
        You need to add a docstring here ! 
        """
        self.type = t


    def getType(self):
        """
        You need to add a docstring here ! 
        """
        return self.type


    def setAction(self, a):
        """
        You need to add a docstring here ! 
        """
        self.action = a


    def getAction(self):
        """
        You need to add a docstring here ! 
        """
        return self.action


    def setParams(self, p):
        """
        You need to add a docstring here ! 
        """
        self.params = p


    def getParams(self):
        """
        You need to add a docstring here ! 
        """
        return self.params


    def setArgs(self, a):
        """
        You need to add a docstring here ! 
        """
        self.args = a


    def getArgs(self):
        """
        You need to add a docstring here ! 
        """
        return self.args


    def addBinding(self, b):
        """
        You need to add a docstring here ! 
        """
        self.bindings.append(b)


    def remBinding(self, b):
        """
        You need to add a docstring here ! 
        """
        if not b in self.bindings:
            return 0
        self.bindings.remove(b)


    def getBindings(self):
        """
        You need to add a docstring here ! 
        """
        return self.bindings


    def addKeyBinding(self, ui, key):
        """
        You need to add a docstring here ! 
        """
        b = Binding(ui)
        b.setKey(key)
        b.setCallback(self.execute)
        self.addBinding(b)


    def setBindings(self, b):
        """
        You need to add a docstring here ! 
        """
        self.bindings = b


    def execute(self, *args, **params):
        """
        You need to add a docstring here ! 
        """
        ma = list(args) + self.args
        mp = self.params
        mp.update(params)
        if self.type == "PC Action":
            i = self.server.getInterface("Player Client")
            return i.do(self.action, *ma, **mp)
        if self.type == "Local Function":
            return self.action( * ma, **mp)
        if self.type == "Remote Function":
            return self.action[0].callRemote(self.action[1],  * ma, **mp)
        raise Exception("Not implimented")


    def activate(self):
        """
        You need to add a docstring here ! 
        """
        for b in self.bindings:
            b.activate()


    def deactivate(self):
        """
        You need to add a docstring here ! 
        """
        for b in self.bindings:
            b.deactivate()
